//--- Variables et constantes globales

const int OPTO = 2; // Broche de l'optocoupleur
volatile int compt = 0; // variable de comptage volatile
int compt0 = 0; // variable pour mémoriser dernière valeur
long millis0 = 0; // variable mémorisation valeur millis()
int delai = 2000; // délai de comptage en millisecondes


#include <TFT.h>  // Arduino LCD library
#include <SPI.h> // Arduino SPI library

/* Définition des broches pour Uno
  Les broches MOSI (broche 11) et SCLK (broche 13) sont déjà définis avec SPI */

#define cs   10
#define dc   9
#define rst  8

// Création d'un objet TFTscreen
TFT TFTscreen = TFT(cs, dc, rst);




char buffer[4]; // buffer de 4 caractères




//--- Fonction setup() : exécutée au début et 1 seule fois
void setup() {

  pinMode(OPTO, INPUT); // broche en entrée
  digitalWrite(OPTO, HIGH); // rappel au plus
  attachInterrupt(0, comptage, FALLING); // Attache l'interruption 0 (broche 2) à la fonction

  // RISING : détection sur front montant
  // FALLING : détection sur front descendant

  millis0 = millis(); // initialise la valeur de millis


  // Initialisation de l'écran

  TFTscreen.begin();





} // fin de la fonction setup()

//--- la fonction loop() : exécutée ensuite en boucle sans fin
void loop() {



  if (millis() - millis0 > delai) { // si le delai s'est écoulé
    compt0 = compt; // mémorise comptage actuel
    millis0 = millis() ; // réinitialise millis0
    compt = 0; // réinitialise comptage



    itoa(compt0, buffer, 10); // conversion de compt0 en 4 caractères décimaux

    // Efface l'écran - fond noir
    TFTscreen.background(0, 0, 0);

    // Ecriture du texte statique sur l'écran
    // Police de couleur blanche
    TFTscreen.stroke(255, 255, 255);

    // Définit la taille de la police
    TFTscreen.setTextSize(2);

    // Ecrit le texte dans le coin supérieur gauche de l'écran
    TFTscreen.text("Vitesse (Rpm)", 2, 5);

    //Définit une taille de police plus grande
    TFTscreen.setTextSize(5);


    // Texte en vert
    TFTscreen.stroke(51, 255, 0);


    // Impression de la vitesse
    TFTscreen.text(buffer, 15, 50);






  } // fin si delai écoulé
} // fin de la fonction loop()

// fonction appelée lors interruption n°0 (broche 2)
void comptage() {
  compt = compt + 1; // incrémente variable comptage
} // fin gestion interruption
